include "%lib%/freshlib.inc"

_BinaryType console     ;   ,    .

include "%lib%/freshlib.asm"

start:
        InitializeAll             ;   .

        stdcall GetCmdArguments   ;       , 
                                  ;    .   
                                  ;      ,
                                  ; ,        .

        mov     edi, eax          ;      ,  
                                  ; FreshLib   TArray

        cmp     [edi+TArray.count], 2
        jne     .error_arguments        ;      , 
                                        ;   .

        stdcall LoadBinaryFile, [edi+TArray.array+4] ;      .
                                                     ;    .
        jc      .error_file_read

        mov     esi, eax                ;       .
        mov     ebx, eax                ;    ebx,     
                                        ; ,  .

;      BOM (windows notepad 

        mov     eax, [esi]
        and     eax, $ffffff

        cmp     ax,  $FEFF    ; low endinan unicode -   .
        je      .error_format
        cmp     ax,  $FFFE    ; big endian unicode -   .
        je      .error_format

        cmp     eax, $BFBBEF    ; UTF-8 BOM
        jne     .utf8_ok

        add     esi, 3  ;   BOM,       .

.utf8_ok:

;    .
;  AL     ,   AH    
;    .
;    ,       
;      .
        xor     ecx, ecx
        xor     eax, eax

.loop:
        mov     al, [esi]
        inc     esi

        cmp     al, ' ' ;      (  
                        ;     ,    , 
                        ;  ..,       .
        jbe     .space

.next:
        mov     ah, al
        jmp     .loop

;   ...
.space:
        cmp     ah, ' '
        jbe     .not_a_word

        inc     ecx

.not_a_word:
        test    al, al
        jnz     .next

;       
.file_end:

;   : "The file contains "
        stdcall FileWrite, [STDOUT], cOutputMessage1, cOutputMessage1.length    ;   

;   ECX    .
;     .
        stdcall NumToStr, ecx, ntsUnsigned or ntsDec
        mov     edx, eax                                ;       -

        stdcall StrLen, edx     ;      ESI
        mov     esi, eax
        stdcall StrPtr, edx     ;       EAX

        stdcall FileWrite, [STDOUT], eax, esi   ;  .
        stdcall StrDel, edx                     ;  ,     .

;        "word"      1
;  "words"      1.

        mov     eax, cOutputMessage3            ;     .
        mov     edx, cOutputMessage3.length

        cmp     ecx, 1
        jne     .suffix

        mov     eax, cOutputMessage2            ;     1,       .
        mov     edx, cOutputMessage2.length

.suffix:
        stdcall FileWrite, [STDOUT], eax, edx

        stdcall FreeMem, ebx
        jmp     .finish

;    .    
;   .display_error         EAX,
;     ECX

.error_format:
        mov     eax, cErrorFormat
        mov     ecx, cErrorFormat.length
        jmp     .display_error

.error_arguments:
        mov     eax, cErrorArguments
        mov     ecx, cErrorArguments.length
        jmp     .display_error

.error_file_read:
        mov     eax, cErrorFileRead
        mov     ecx, cErrorFileRead.length

.display_error:
        stdcall FileWrite, [STDERR], eax, ecx

;  
.finish:
        FinalizeAll             ;   .
        stdcall Terminate, 0


;   .

cErrorArguments text 'Error! Wrong argument count.', 13, 10, 'Usage: word_count filename', 13, 10
cErrorFileRead  text 'Error read file.', 13, 10
cErrorFormat    text 'Error! Unsupported format.', 13, 10

; ,     .

cOutputMessage1 text 'The file contains '
cOutputMessage2 text ' word.', 13, 10
cOutputMessage3 text ' words.', 13, 10

;          .
;              .
;
;    _AllImportSection  _AllDataSection     
;   .      -    Windows.

_AllImportEmbeded
_AllDataEmbeded
